"""
Inspired by work done by Emma Dybro Thomassen, PhD-student at DTU 2019
Modified by Agnethe Nedergaard Pedersen, PhD-student at DTU 2019
"""

import datetime
import numpy as np
import pandas as pd

def FromDanishDSTtimeToUTC(input_t):
    # Convert Flow data to UTC
    t=input_t
    # Create index values for shift in summer/witner time
    sshift9 = datetime.datetime(2009,3,29,2,00,00)
    sshift10 = datetime.datetime(2010,3,28,2,00,00)
    sshift11 = datetime.datetime(2011,3,27,2,00,00)
    sshift12 = datetime.datetime(2012,3,25,2,00,00)
    sshift13 = datetime.datetime(2013,3,31,2,00,00)
    sshift14 = datetime.datetime(2014,3,30,2,00,00)
    sshift15 = datetime.datetime(2015,3,29,2,00,00)
    sshift16 = datetime.datetime(2016,3,27,2,00,00)
    sshift17 = datetime.datetime(2017,3,26,2,00,00)
    sshift18 = datetime.datetime(2018,3,25,2,00,00)
    sshift19 = datetime.datetime(2019,3,31,2,00,00)
    sshift20 = datetime.datetime(2020,3,29,2,00,00)
    sshift21 = datetime.datetime(2021,3,28,2,00,00)
    wshift9 = datetime.datetime(2009,10,25,2,00,00) # 2 o'clock instead of 3 o'clock as the wintertime change the time one hour back
    wshift10 = datetime.datetime(2010,10,31,2,00,00) # 2 o'clock instead of 3 o'clock as the wintertime change the time one hour back
    wshift11 = datetime.datetime(2011,10,30,2,00,00) # 2 o'clock instead of 3 o'clock as the wintertime change the time one hour back
    wshift12 = datetime.datetime(2012,10,28,2,00,00) # 2 o'clock instead of 3 o'clock as the wintertime change the time one hour back
    wshift13 = datetime.datetime(2013,10,27,2,00,00) # 2 o'clock instead of 3 o'clock as the wintertime change the time one hour back
    wshift14 = datetime.datetime(2014,10,26,2,00,00) # 2 o'clock instead of 3 o'clock as the wintertime change the time one hour back
    wshift15 = datetime.datetime(2015,10,25,2,00,00) # 2 o'clock instead of 3 o'clock as the wintertime change the time one hour back
    wshift16 = datetime.datetime(2016,10,30,2,00,00) # 2 o'clock instead of 3 o'clock as the wintertime change the time one hour back
    wshift17 = datetime.datetime(2017,10,29,2,00,00) # 2 o'clock instead of 3 o'clock as the wintertime change the time one hour back
    wshift18 = datetime.datetime(2018,10,28,2,00,00) # 2 o'clock instead of 3 o'clock as the wintertime change the time one hour back
    wshift19 = datetime.datetime(2019,10,27,2,00,00) # 2 o'clock instead of 3 o'clock as the wintertime change the time one hour back
    wshift20 = datetime.datetime(2020,10,25,2,00,00) # 2 o'clock instead of 3 o'clock as the wintertime change the time one hour back
    wshift21 = datetime.datetime(2021,10,31,2,00,00) # 2 o'clock instead of 3 o'clock as the wintertime change the time one hour back
    wshiftindex = [wshift9, wshift10, wshift11, wshift12, wshift13, wshift14, wshift15, wshift16, wshift17, wshift18, wshift19, wshift20, wshift21]
    shiftindex9 = np.where(np.logical_and(t>=sshift9,t<wshift9))[0]
    shiftindex10 = np.where(np.logical_and(t>=sshift10,t<wshift10))[0]
    shiftindex11 = np.where(np.logical_and(t>=sshift11,t<wshift11))[0]
    shiftindex12 = np.where(np.logical_and(t>=sshift12,t<wshift12))[0]
    shiftindex13 = np.where(np.logical_and(t>=sshift13,t<wshift13))[0]
    shiftindex14 = np.where(np.logical_and(t>=sshift14,t<wshift14))[0]
    shiftindex15 = np.where(np.logical_and(t>=sshift15,t<wshift15))[0]
    shiftindex16 = np.where(np.logical_and(t>=sshift16,t<wshift16))[0]
    shiftindex17 = np.where(np.logical_and(t>=sshift17,t<wshift17))[0]
    shiftindex18 = np.where(np.logical_and(t>=sshift18,t<wshift18))[0]
    shiftindex19 = np.where(np.logical_and(t>=sshift19,t<wshift19))[0]
    shiftindex20 = np.where(np.logical_and(t>=sshift20,t<wshift20))[0]
    shiftindex21 = np.where(np.logical_and(t>=sshift21,t<wshift21))[0]
    shiftindex = [*shiftindex9, *shiftindex10, *shiftindex11, *shiftindex12, *shiftindex13, *shiftindex14,*shiftindex15,
                  *shiftindex16, *shiftindex17, *shiftindex18, *shiftindex19, *shiftindex20, *shiftindex21]
    # Convert time series to UTC
    t_UTC = t - datetime.timedelta(hours=1) # Substract one hour from all data
    t_UTC1=pd.DataFrame(t_UTC, index=range(len(t_UTC)), columns=['time'])
    t_UTC1.iloc[shiftindex,0]=t_UTC1.iloc[shiftindex,0] - pd.Timedelta(hours=1) # Substract an extra hour at summer time

  
    #Ensures that the double values in shift to wintertime is not located double. No matter what time a double value start as. 
    for i in range(0, len(wshiftindex)): 
       
        if int((wshiftindex[i]-pd.Timedelta(hours=1)) > t_UTC1.iloc[0]) & int(wshiftindex[i] < t_UTC1.iloc[-1]): #apply only for valid data
            tstart = t_UTC1.loc[t_UTC1['time']>(wshiftindex[i]-pd.Timedelta(hours=1))].iloc[[0,]].index[0]
            t_realend = t_UTC1.loc[t_UTC1['time']>(wshiftindex[i])].iloc[[0,]].index[0]
            tend = 0

            if t_realend > 0:
                for j in range(tstart, t_realend):
        
                    if t_UTC1.time[j] > t_UTC1.time[j+1]:
                        tend = j+1
                        t_UTC1.time[(tstart-1):tend]=(t_UTC1.time[(tstart-1):tend] - pd.Timedelta(hours=1))
                    else: 
                        pass
   
    
    return t_UTC1


