import os
from datetime import datetime
from datetime import timedelta
import datetime
import numpy as np
import pandas as pd
import re


os.chdir("C:\\_Sager\\_PhD\\Project\\lib")

from FromDanishDSTtimeToUTC import FromDanishDSTtimeToUTC

os.chdir("C:\\_Sager\\_PhD\\Project")


#from Tool_ReadData_2_UTCtime import import_system2000, import_ifix, import_danova
#%%
#Import from three different sources, System2000, Ifix and Danova
#Convert to UTC time
#Convert to same unit


#Read System2000 data
def import_system2000(path, conversion):
    #System2000
    df = pd.read_csv(path, sep=";",header=0, skipinitialspace=True)
    
    #Change time to UTC
    dst_boolean = df['BASE'] == (4096 or 6144) # if 0 it is winter time, if 4096 it is summer time  
    dst_boolean = dst_boolean.to_numpy()

    pd_time_array = pd.to_datetime(list(df['TIME']),format="%Y.%m.%d %H:%M:%S") # turns a string into a datetime object
    pd_time_array = pd_time_array.tz_localize(tz='Europe/Copenhagen',ambiguous=dst_boolean).tz_convert('UTC') # tz_localize sets the time zone of a time stamps, tz_convert changes a time to another zone
    pd_time_array = pd_time_array.tz_convert(None)
    
    raw_data = pd.DataFrame({'time': pd_time_array,
                         'value': df.iloc[:,2]})

    #Convert to same unit
    raw_data['value']=raw_data['value']/conversion #convert to m
    
    
    return raw_data

def import_ifix(path, conversion):
    #IFIX
  
    dfI = pd.read_fwf(path, decimal=",", sep='\t', parse_dates=True, skiprows=(1), skipfooter=(3))
    dfI.columns = ['time','value','Quality'] #Nyt navn til kolonner da gamle er mærkelige

    #Convert scientific number with commas with dots
    dfI['value'] = pd.to_numeric(dfI['value'].apply(lambda x: re.sub(',', '.', str(x))))
    dfI['time'] = pd.to_datetime(dfI['time'], format="%Y-%m-%d %H:%M:%S.%f") #Gør så data bliver i rigtig dato format

    #Change time to UTC - easiest for now!
    dfI['UTCtime'] =  FromDanishDSTtimeToUTC(dfI['time'])
    
            
    raw_data = pd.DataFrame({'time': dfI['UTCtime'],
                         'value': round(dfI['value'],3), #round data
                         'quality_ifix':dfI['Quality']})
    
    raw_data['value']=raw_data['value']/conversion #convert to m

    return raw_data


def import_danova(path, conversion):
    df = pd.read_csv(path, decimal=",", sep='\t', parse_dates=True, skiprows=1, 
                     usecols=[0,1])
    df.columns = ["time", "value"]
    
    #Make the time in correct format
    df['time'] = pd.to_datetime(df['time'], format="%d-%m-%Y %H:%M:%S")
#    df = df.set_index('time')

    #Change time to UTC - easiest for now!
    df['UTCtime'] =  FromDanishDSTtimeToUTC(df['time'])
    df['value']=df['value']/conversion #convert to m
 
        
    raw_data = pd.DataFrame({'time': df['UTCtime'],
                         'value': df['value']})
    
    return raw_data

def Fill_data_savings_points(df, time='time', Timeperiod = '1min'): #df is a dataframe, time is name of time column, Timeperiod is min time period

    df['ffill'] = pd.Series(np.zeros(len(df)),dtype=bool)    
    df[time] = pd.to_datetime(df[time])
    #new_df = df.set_index(time, drop=True)
    new_df = pd.DataFrame()
    for i in range(0,(len(df[time])-1)):
        if df[time][i+1]-df[time][i] > pd.Timedelta(minutes=1):
            start = (df[time][i]+pd.Timedelta(minutes=1))
            periods = (df[time][i+1]-df[time][i])/pd.Timedelta(minutes =1)
            if periods%1>0: #Find the modulus of periods
                b = pd.date_range(start = start, periods = periods, freq = Timeperiod )
            else: #Ensure that there will not be identical timeperiods if the modulus is 1
                b = pd.date_range(start = start, periods = (periods-1), freq = Timeperiod ) 
            b = pd.DataFrame(data=b)
            b['ffill'] = True
            new_df = new_df.append(b)
            
    new_df.columns = [time, 'ffill']
    output = df.append(new_df, sort = False)
    output.sort_values(by=[time], inplace=True)
    output = output.reset_index(drop=True)
   
    return output

def NoFill_data_savings_points(df, time='time', Timeperiod = '1min'): #df is a dataframe, time is name of time column, Timeperiod is min time period
    flag_pad = pd.Series(np.zeros(len(df.value)),dtype=bool)    
    output = pd.DataFrame({'time': df['time'],
                         'value': df['value'],
                         'ffill': flag_pad})
    
    return output


